using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Chart;

namespace WindowsApplication4
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Chart.ChartControl chartControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private void InitializeControlSettings()
		{
			this.chartControl1.Font = new System.Drawing.Font("Arial", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));

			// Specify a ChartPalette:
			Color[] color = new Color[]{Color.FromArgb(185, 73,141,238), Color.FromArgb(185,247,179,78),Color.FromArgb(185,186,66,30)};
			this.chartControl1.Palette = ChartColorPalette.Custom ;

			this.chartControl1.Model.ColorModel.CustomColors = color;
			this.chartControl1.Palette = ChartColorPalette.Custom ;

			this.chartControl1.ChartInterior = new Syncfusion.Drawing.BrushInfo(185,new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, Color.LightBlue , Color.Azure));
						
			this.chartControl1.HidePartialLabels = true;
		}

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InitializeControlSettings();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.chartControl1 = new Syncfusion.Windows.Forms.Chart.ChartControl();
			this.SuspendLayout();
			// 
			// chartControl1
			// 
			this.chartControl1.Controls.Add(this.chartControl1.Legend);
			this.chartControl1.Dock = System.Windows.Forms.DockStyle.Fill;
			// 
			// chartControl1.Legend
			// 
			this.chartControl1.Legend.Font = new System.Drawing.Font("Verdana", 10F);
			this.chartControl1.Legend.ItemsShadowColor = System.Drawing.Color.Gray;
			this.chartControl1.Legend.Location = new System.Drawing.Point(454, 192);
			this.chartControl1.Legend.Name = "";
			this.chartControl1.Legend.TabIndex = 3;
			this.chartControl1.Location = new System.Drawing.Point(0, 0);
			this.chartControl1.Name = "chartControl1";
			this.chartControl1.PrimaryXAxis.LabelAligment = System.Drawing.StringAlignment.Center;
			this.chartControl1.PrimaryXAxis.Orientation = Orientation.Horizontal;
			this.chartControl1.PrimaryYAxis.LabelAligment = System.Drawing.StringAlignment.Center;
			this.chartControl1.Size = new System.Drawing.Size(552, 374);
			this.chartControl1.TabIndex = 0;
			this.chartControl1.Text = "Essential Chart";
			this.chartControl1.ToolBar.Location = new System.Drawing.Point(0, 0);
			this.chartControl1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.chartControl1_MouseDown);
			this.chartControl1.MouseUp += new System.Windows.Forms.MouseEventHandler(this.chartControl1_MouseUp);
			this.chartControl1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.chartControl1_MouseMove);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(552, 374);
			this.Controls.Add(this.chartControl1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.Text = "Essential Chart - Sample Application";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private bool bHaveMouse;
		private Point ptOriginal = new Point();
		private Point ptLast = new Point();
	

		// Convert and normalize the points and draw the reversible frame.
		private void MyDrawReversibleRectangle( Point p1, Point p2)
		{
			Rectangle rc = this.chartControl1.Bounds;

			// Convert the points to screen coordinates.

			p1 = this.chartControl1.PointToScreen(p1);
			p2 = this.chartControl1.PointToScreen(p2);
			
			// Normalize the rectangle.
			if( p1.X < p2.X )
			{
				rc.X = p1.X;
				rc.Width = p2.X - p1.X;
			}
			else
			{
				rc.X = p2.X;
				rc.Width = p1.X - p2.X;
			}
			if( p1.Y < p2.Y )
			{
				rc.Y = p1.Y;
				rc.Height = p2.Y - p1.Y;
			}
			else
			{
				rc.Y = p2.Y;
				rc.Height = p1.Y - p2.Y;
			}
			
			// Draw the reversible frame.
			ControlPaint.DrawReversibleFrame( rc, Color.DarkRed, FrameStyle.Dashed);
			this.chartControl1.Paint+=new PaintEventHandler(chartControl1_Paint);
			this.chartControl1.ChartAreaPaint+=new PaintEventHandler(chartControl1_ChartAreaPaint);
		}

		private void chartControl1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			// Set internal flag to know we no longer "have the mouse".
			bHaveMouse = false;
			
			// If we have drawn previously, draw again in that spot
			// to remove the lines.
			if( ptLast.X != -1 )
			{
				//Point ptCurrent = new Point( e.X, e.Y );
				MyDrawReversibleRectangle( ptOriginal, ptLast);
			}
			// Set flags to know that there is no "previous" line to reverse.
			ptLast.X = -1;
			ptLast.Y = -1;
			ptOriginal.X = -1;
			ptOriginal.Y = -1;
		}

		private void chartControl1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			Point ptCurrent = new Point( e.X, e.Y );

			// If we "have the mouse", then we draw our lines.
			if(bHaveMouse )
			{
				// If we have drawn previously, draw again in
				// that spot to remove the lines.
				if( ptLast.X != -1 )
				{
					//MyDrawReversibleRectangle( ptOriginal, ptLast );
				}
				// Update last point.
				ptLast = ptCurrent;
				// Draw new lines.
				MyDrawReversibleRectangle( ptOriginal, ptCurrent );
			}
		}

		private void chartControl1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			// Make a note that we "have the mouse".
			bHaveMouse = true;
			// Store the "starting point" for this rubber-band rectangle.
			ptOriginal.X =  e.X;
			ptOriginal.Y =  e.Y;
			// Special value lets us know that no previous
			// rectangle needs to be erased.
			ptLast.X = -1;
			ptLast.Y = -1;
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			InitializeChartData();
		}

		protected void InitializeChartData()
		{
			this.chartControl1.Legend.Visible = false;
			ChartSeries series = this.chartControl1.Model.NewSeries("Series",ChartSeriesType.Column);
			series.Text = series.Name;

			Random r = new Random();

			for(int i=0;i<10;i++)
				series.Points.Add(i,r.Next(20,50));

			this.chartControl1.Series.Add(series);
		}

		private void chartControl1_Paint(object sender, PaintEventArgs e)
		{
			this.chartControl1.Redraw(false);
		}

		private void chartControl1_ChartAreaPaint(object sender, PaintEventArgs e)
		{
			this.chartControl1.Redraw(false);
		}
	}
}